import ctypes

from glob import glob

_lib = ctypes.CDLL(glob('/opt/edge/lib/libimproc-opencv*.so')[0])


class Rect(ctypes.Structure):
    _fields_ = [
        ('l', ctypes.c_int),
        ('t', ctypes.c_int),
        ('w', ctypes.c_int),
        ('h', ctypes.c_int)
    ]


# void
# ImProcOcvContrastImproveRgba(double aClipLimit, int aGridRows, int aGridCols, const improc_rect_t *aRoi,
# int aDataWidth, int aDataHeight, int aDataStride, const void *aDataSource, void *aDataTarget);
ocv_improve_contrast_grba = _lib.ImProcOcvContrastImproveRgba
ocv_improve_contrast_grba.argtypes = (
    ctypes.c_double, ctypes.c_int, ctypes.c_int, ctypes.POINTER(Rect),
    ctypes.c_int, ctypes.c_int, ctypes.c_int, ctypes.c_void_p, ctypes.c_void_p)
